明经CAD社区

 找回密码
 注册

QQ登录

只需一步,快速开始

搜索
查看: 1061|回复: 5

如何不用拖选就能把所有的直线选中

[复制链接]
发表于 2011-8-12 10:26:45 | 显示全部楼层 |阅读模式
本帖最后由 介之推 于 2011-8-12 12:40 编辑

大家好,通过定义选择集来选择时需要在窗口上用鼠标拖动光标来选择,有没有不用拖选就能直接选中所有的直线?下面的代码需要手动选才行。
[CommandMethod("AllLines")]
        public void seletcAllLines()
        {
            Document doc = Autodesk.AutoCAD.ApplicationServices.Application.DocumentManager.MdiActiveDocument;
            Database db = doc.Database;
            Editor ed = doc.Editor;
            using (Transaction trans = db.TransactionManager.StartTransaction())
            {
                try
                {
                    //define the criteria for selecting lines only
                    TypedValue[] tv = new TypedValue[] { new TypedValue((int)DxfCode.Start, "LINE") };
                    SelectionFilter flt = new SelectionFilter(tv);
                    /*This method needs to drag the cursor,which I think is not smart.
                     I will want to improve*/
                    PromptSelectionOptions optSel = new PromptSelectionOptions();
                    optSel.MessageForAdding = "You will need to drag this cursor to select.";
                    PromptSelectionResult resSel = ed.GetSelection(optSel,flt);
                    SelectionSet selSet = resSel.Value;
                    ObjectId[] ids = selSet.GetObjectIds();
                    foreach (ObjectId sSetEntId in ids)
                    {
                        
                        Entity ent = (Entity)trans.GetObject(sSetEntId, OpenMode.ForWrite);
                        if (ent.GetType().Name=="Line") //请问有更好的判断方法吗?typeof(ent) is Line在这里出错。
                        {
                            Line myLine = (Line)trans.GetObject(sSetEntId, OpenMode.ForWrite);
                            ed.WriteMessage("\n"+myLine.StartPoint.ToString()+ myLine.EndPoint.ToString());
                        }
                     
             }
                    trans.Commit();
                }
                catch(System.Exception ex)
                {
                    ed.WriteMessage(ex.Message + "\n" + ex.StackTrace);
                }
            }
        }

发表于 2011-8-12 16:23:03 | 显示全部楼层
试试直接用ObjectId——
foreach (ObjectId sSetEntId in ids)
{
                        
       //Entity ent = (Entity)trans.GetObject(sSetEntId, OpenMode.ForWrite);

       if (sSetEntId.ObjectClass.DFXName == "LINE")
       {
            Line myLine = (Line)trans.GetObject(sSetEntId, OpenMode.ForWrite);
            ed.WriteMessage("\n"+myLine.StartPoint.ToString()+ myLine.EndPoint.ToString());
       }
   
}
发表于 2011-8-13 10:47:18 | 显示全部楼层
遍历数据库
发表于 2011-8-13 10:55:30 | 显示全部楼层
     if (ent.GetType().Name=="Line") //请问有更好的判断方法吗?typeof(ent) is Line在这里出错
1,ent is Line
2, ent.GetType(). == typeof(Line)
3,public Autodesk.AutoCAD.EditorInput.PromptSelectionResult SelectAll(Autodesk.AutoCAD.EditorInput.SelectionFilter filter)
    Autodesk.AutoCAD.EditorInput.Editor 的成员
发表于 2011-8-14 14:40:20 | 显示全部楼层
vs2008的话试试linq吧
发表于 2011-8-15 00:20:46 | 显示全部楼层
TypedValue[] tv = new TypedValue[] { new TypedValue(0, "LINE") };

有了这句话,不可能选中非line对象的
您需要登录后才可以回帖 登录 | 注册

本版积分规则

小黑屋|手机版|CAD论坛|CAD教程|CAD下载|联系我们|关于明经|明经通道 ( 粤ICP备05003914号 )  
©2000-2023 明经通道 版权所有 本站代码,在未取得本站及作者授权的情况下,不得用于商业用途

GMT+8, 2024-11-25 20:32 , Processed in 0.160340 second(s), 24 queries , Gzip On.

Powered by Discuz! X3.4

Copyright © 2001-2021, Tencent Cloud.

快速回复 返回顶部 返回列表